#include "eeprom.h"

// 		IapEraseSector(IAP_ADDRESS);    //
//    for (i=0; i<512; i++)           //Ƿɹ(ȫFF)
//    {
//        if (IapReadByte(IAP_ADDRESS+i) != 0xff)
//            goto Error;             //,˳
//    }
//    P1 = 0xfc;                      //1111,1100 ɹ
//    Delay(10);                      //ʱ
//    for (i=0; i<512; i++)           //512ֽ
//    {
//        IapProgramByte(IAP_ADDRESS+i, (BYTE)i);
//    }

/*----------------------------
رIAP
----------------------------*/
void IapIdle()
{
    IAP_CONTR = 0;                  //رIAP
    IAP_CMD = 0;                    //Ĵ
    IAP_TRIG = 0;                   //Ĵ
    IAP_ADDRH = 0x80;               //ַõIAP
    IAP_ADDRL = 0;
}

/*----------------------------
ISP/IAP/EEPROMȡһֽ
----------------------------*/
u8 IapReadu8(u16 addr)
{
    u8 dat;                       //ݻ

    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_READ;             //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    dat = IAP_DATA;                 //ISP/IAP/EEPROM
    IapIdle();                      //رIAP

    return dat;                     //
}

/*----------------------------
дһֽݵISP/IAP/EEPROM
----------------------------*/
void IapProgramu8(u16 addr, u8 dat)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_PROGRAM;          //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_DATA = dat;                 //дISP/IAP/EEPROM
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    IapIdle();
}

/*----------------------------

----------------------------*/
void IapEraseSector(u16 addr)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_ERASE;            //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    IapIdle();
}


